Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/toolchain.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -31,20 +31,31 @@
 BINUTILS_GDB_GIT="https://github.com/HelenOS/binutils-gdb.git"
 
-BINUTILS_BRANCH="binutils-2_31_1-helenos"
-BINUTILS_VERSION="2.31.1"
-
-GDB_BRANCH="gdb-8_2-helenos"
-GDB_VERSION="8.2"
+BINUTILS_BRANCH="binutils-2_41-helenos"
+BINUTILS_VERSION="2.41"
+
+GDB_BRANCH="gdb-13.2-helenos"
+GDB_VERSION="13.2"
 
 GCC_GIT="https://github.com/HelenOS/gcc.git"
-GCC_BRANCH="8_2_0-helenos"
-GCC_VERSION="8.2.0"
+GCC_BRANCH="13_2_0-helenos"
+GCC_VERSION="13.2"
 
 BASEDIR="$PWD"
 SRCDIR="$(readlink -f $(dirname "$0"))"
 
+# If we install into a temporary directory and copy from there,
+# we don't have to trust the upstream makefiles respect the prefix for
+# all files, and we also have a ready-made package for distribution.
+INSTALL_DIR="${BASEDIR}/PKG"
+
 SYSTEM_INSTALL=false
-REAL_INSTALL=true
-USE_HELENOS_TARGET=true
+
+BUILD_GDB=false
+BUILD_BINUTILS=true
+BUILD_GCC=true
+
+if [ -z "$JOBS" ] ; then
+	JOBS="`nproc`"
+fi
 
 check_error() {
@@ -61,5 +72,5 @@
 	echo
 	echo "Syntax:"
-	echo " $0 [--system-wide] [--no-install] [--non-helenos-target] <platform>"
+	echo " $0 [--system-wide] [--with-gdb|--only-gdb] <platform>"
 	echo " $0 [--system-wide] --test-version [<platform>]"
 	echo
@@ -76,5 +87,4 @@
 	echo " sparc64    SPARC V9"
 	echo " all        build all targets"
-	echo " essential  build only targets currently needed for HelenOS development"
 	echo " parallel   same as 'all', but all in parallel"
 	echo " 2-way      same as 'all', but 2-way parallel"
@@ -92,11 +102,4 @@
 	echo "     variable is not set, then the default value of \$HOME/.local/share"
 	echo "     is assumed."
-	echo
-	echo "If the --no-install option is used, the toolchain still uses the"
-	echo "target installation directory as determined above, but the files"
-	echo "are actually copied into the PKG/ subdirectory during the installation"
-	echo "without affecting the actual target file system. This might be useful"
-	echo "when preparing a system-wide installation, but avoiding running this"
-	echo "script under the super user."
 	echo
 	echo "The --non-helenos-target option will build non-HelenOS-specific"
@@ -139,5 +142,5 @@
 	for PLATFORM in $PLATFORMS ; do
 		set_target_from_platform "$PLATFORM"
-		PREFIX="${CROSS_PREFIX}/bin/${HELENOS_TARGET}"
+		PREFIX="${CROSS_PREFIX}/bin/${TARGET}"
 
 		echo "== $PLATFORM =="
@@ -177,4 +180,16 @@
 }
 
+ring_bell() {
+	printf '\a'
+	sleep 0.1
+	printf '\a'
+	sleep 0.1
+	printf '\a'
+	sleep 0.1
+	printf '\a'
+	sleep 0.1
+	printf '\a'
+}
+
 show_countdown() {
 	TM="$1"
@@ -241,17 +256,17 @@
 
 check_dirs() {
-	OUTSIDE="$1"
-	BASE="$2"
-	ORIGINAL="$PWD"
-
-	cd "${BASE}"
-	check_error $? "Unable to change directory to ${BASE}."
+	cd "${BASEDIR}"
+	check_error $? "Unable to change directory to ${BASEDIR}."
 	ABS_BASE="$PWD"
-	cd "${ORIGINAL}"
-	check_error $? "Unable to change directory to ${ORIGINAL}."
-
-	mkdir -p "${OUTSIDE}"
-	cd "${OUTSIDE}"
-	check_error $? "Unable to change directory to ${OUTSIDE}."
+
+	if $SYSTEM_INSTALL && [ ! -d "${CROSS_PREFIX}" ]; then
+		ring_bell
+		( set -x ; sudo -k mkdir -p "${CROSS_PREFIX}" )
+	else
+		mkdir -p "${CROSS_PREFIX}"
+	fi
+
+	cd "${CROSS_PREFIX}"
+	check_error $? "Unable to change directory to ${CROSS_PREFIX}."
 
 	while [ "${#PWD}" -gt "${#ABS_BASE}" ]; do
@@ -266,6 +281,5 @@
 	fi
 
-	cd "${ORIGINAL}"
-	check_error $? "Unable to change directory to ${ORIGINAL}."
+	cd "${BASEDIR}"
 }
 
@@ -280,18 +294,33 @@
 	change_title "Downloading sources"
 	echo ">>> Downloading sources"
-	git clone --depth 1 -b "$BINUTILS_BRANCH" "$BINUTILS_GDB_GIT" "binutils-$BINUTILS_VERSION"
-	git clone --depth 1 -b "$GDB_BRANCH" "$BINUTILS_GDB_GIT" "gdb-$GDB_VERSION"
-	git clone --depth 1 -b "$GCC_BRANCH" "$GCC_GIT" "gcc-$GCC_VERSION"
-
-	# If the directory already existed, pull upstream changes.
-	git -C "binutils-$BINUTILS_VERSION" pull
-	git -C "gdb-$GDB_VERSION" pull
-	git -C "gcc-$GCC_VERSION" pull
-
-	change_title "Downloading GCC prerequisites"
-	echo ">>> Downloading GCC prerequisites"
-	cd "gcc-${GCC_VERSION}"
-	./contrib/download_prerequisites
-	cd ..
+
+	if $BUILD_BINUTILS ; then
+		git clone --depth 1 -b "$BINUTILS_BRANCH" "$BINUTILS_GDB_GIT" "binutils-$BINUTILS_VERSION"
+		# If the directory already existed, pull upstream changes.
+		git -C "binutils-$BINUTILS_VERSION" pull
+	fi
+
+	if $BUILD_GCC ; then
+		git clone --depth 1 -b "$GCC_BRANCH" "$GCC_GIT" "gcc-$GCC_VERSION"
+		git -C "gcc-$GCC_VERSION" pull
+
+		change_title "Downloading GCC prerequisites"
+		echo ">>> Downloading GCC prerequisites"
+		cd "gcc-${GCC_VERSION}"
+		./contrib/download_prerequisites
+		cd ..
+	fi
+
+	if $BUILD_GDB ; then
+		git clone --depth 1 -b "$GDB_BRANCH" "$BINUTILS_GDB_GIT" "gdb-$GDB_VERSION"
+		git -C "gdb-$GDB_VERSION" pull
+	fi
+
+	# This sets the CROSS_PREFIX variable
+	set_cross_prefix
+
+	DESTDIR_SPEC="DESTDIR=${INSTALL_DIR}"
+
+	check_dirs
 }
 
@@ -321,74 +350,27 @@
 	esac
 
-	HELENOS_TARGET="${GNU_ARCH}-helenos"
-
-	case "$1" in
-		"arm32")
-			LINUX_TARGET="${GNU_ARCH}-linux-gnueabi"
-			;;
-		*)
-			LINUX_TARGET="${GNU_ARCH}-linux-gnu"
-			;;
-	esac
-}
-
-build_target() {
-	PLATFORM="$1"
-
-	# This sets the *_TARGET variables
-	set_target_from_platform "$PLATFORM"
-	if $USE_HELENOS_TARGET ; then
-		TARGET="$HELENOS_TARGET"
-	else
-		TARGET="$LINUX_TARGET"
-	fi
+	TARGET="${GNU_ARCH}-helenos"
+}
+
+build_binutils() {
+	# This sets the TARGET variable
+	set_target_from_platform "$1"
 
 	WORKDIR="${BASEDIR}/${TARGET}"
-	INSTALL_DIR="${BASEDIR}/PKG"
 	BINUTILSDIR="${WORKDIR}/binutils-${BINUTILS_VERSION}"
-	GCCDIR="${WORKDIR}/gcc-${GCC_VERSION}"
-	GDBDIR="${WORKDIR}/gdb-${GDB_VERSION}"
-
-	# This sets the CROSS_PREFIX variable
-	set_cross_prefix
-
-	if [ -z "$JOBS" ] ; then
-		JOBS="`nproc`"
-	fi
-
-	PREFIX="${CROSS_PREFIX}"
 
 	echo ">>> Removing previous content"
 	cleanup_dir "${WORKDIR}"
 	mkdir -p "${WORKDIR}"
-	check_dirs "${PREFIX}" "${WORKDIR}"
-
-	if $USE_HELENOS_TARGET ; then
-		change_title "Creating build sysroot"
-		echo ">>> Creating build sysroot"
-		mkdir -p "${WORKDIR}/sysroot/include"
-		mkdir "${WORKDIR}/sysroot/lib"
-		ARCH="$PLATFORM"
-		if [ "$ARCH" = "mips32eb" ]; then
-			ARCH=mips32
-		fi
-
-		cp -r -L -t "${WORKDIR}/sysroot/include" \
-			${SRCDIR}/../abi/include/* \
-			${SRCDIR}/../uspace/lib/c/arch/${ARCH}/include/* \
-			${SRCDIR}/../uspace/lib/c/include/*
-		check_error $? "Failed to create build sysroot."
-	fi
-
-
-	echo ">>> Processing binutils (${PLATFORM})"
+
+	echo ">>> Processing binutils (${TARGET})"
 	mkdir -p "${BINUTILSDIR}"
 	cd "${BINUTILSDIR}"
 	check_error $? "Change directory failed."
 
-	change_title "binutils: configure (${PLATFORM})"
+	change_title "binutils: configure (${TARGET})"
 	CFLAGS="-Wno-error -fcommon" "${BASEDIR}/downloads/binutils-${BINUTILS_VERSION}/configure" \
 		"--target=${TARGET}" \
-		"--prefix=${PREFIX}" \
+		"--prefix=${CROSS_PREFIX}" \
 		"--program-prefix=${TARGET}-" \
 		--disable-nls \
@@ -400,28 +382,35 @@
 	check_error $? "Error configuring binutils."
 
-	change_title "binutils: make (${PLATFORM})"
+	change_title "binutils: make (${TARGET})"
 	make all -j$JOBS
 	check_error $? "Error compiling binutils."
 
-	change_title "binutils: install (${PLATFORM})"
-	make install "DESTDIR=${INSTALL_DIR}"
+	change_title "binutils: install (${TARGET})"
+	make install $DESTDIR_SPEC
 	check_error $? "Error installing binutils."
-
-
-	echo ">>> Processing GCC (${PLATFORM})"
+}
+
+build_gcc() {
+	# This sets the TARGET variable
+	set_target_from_platform "$1"
+
+	WORKDIR="${BASEDIR}/${TARGET}"
+	GCCDIR="${WORKDIR}/gcc-${GCC_VERSION}"
+
+	echo ">>> Removing previous content"
+	cleanup_dir "${WORKDIR}"
+	mkdir -p "${WORKDIR}"
+
+	echo ">>> Processing GCC (${TARGET})"
 	mkdir -p "${GCCDIR}"
 	cd "${GCCDIR}"
 	check_error $? "Change directory failed."
 
-	if $USE_HELENOS_TARGET ; then
-		SYSROOT=--with-sysroot --with-build-sysroot="${WORKDIR}/sysroot"
-	else
-		SYSROOT=--without-headers
-	fi
-
-	change_title "GCC: configure (${PLATFORM})"
-	PATH="$PATH:${INSTALL_DIR}/${PREFIX}/bin" "${BASEDIR}/downloads/gcc-${GCC_VERSION}/configure" \
+	BUILDPATH="${CROSS_PREFIX}/bin:${PATH}"
+
+	change_title "GCC: configure (${TARGET})"
+	PATH="${BUILDPATH}" "${BASEDIR}/downloads/gcc-${GCC_VERSION}/configure" \
 		"--target=${TARGET}" \
-		"--prefix=${PREFIX}" \
+		"--prefix=${CROSS_PREFIX}" \
 		"--program-prefix=${TARGET}-" \
 		--with-gnu-as \
@@ -432,72 +421,98 @@
 		--disable-shared \
 		--disable-werror \
-		$SYSROOT
+		--without-headers  # TODO: Replace with proper sysroot so we can build more libs
 	check_error $? "Error configuring GCC."
 
-	change_title "GCC: make (${PLATFORM})"
-	PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-gcc -j$JOBS
+	change_title "GCC: make (${TARGET})"
+	PATH="${BUILDPATH}" make all-gcc -j$JOBS
 	check_error $? "Error compiling GCC."
 
-	if $USE_HELENOS_TARGET ; then
-		PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libgcc -j$JOBS
-		check_error $? "Error compiling libgcc."
-		# TODO: libatomic and libstdc++ need some extra care
-		#    PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libatomic -j$JOBS
-		#    check_error $? "Error compiling libatomic."
-		#    PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libstdc++-v3 -j$JOBS
-		#    check_error $? "Error compiling libstdc++."
-	fi
-
-	change_title "GCC: install (${PLATFORM})"
-	PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-gcc "DESTDIR=${INSTALL_DIR}"
-	if $USE_HELENOS_TARGET ; then
-		PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libgcc "DESTDIR=${INSTALL_DIR}"
-		#    PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libatomic "DESTDIR=${INSTALL_DIR}"
-		#    PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libstdc++-v3 "DESTDIR=${INSTALL_DIR}"
-	fi
+	change_title "GCC: install (${TARGET})"
+	PATH="${BUILDPATH}" make install-gcc $DESTDIR_SPEC
 	check_error $? "Error installing GCC."
-
-
-	echo ">>> Processing GDB (${PLATFORM})"
+}
+
+build_libgcc() {
+	# This sets the TARGET variable
+	set_target_from_platform "$1"
+
+	WORKDIR="${BASEDIR}/${TARGET}"
+	GCCDIR="${WORKDIR}/gcc-${GCC_VERSION}"
+
+	# No removing previous content here, we need the previous GCC build
+
+	cd "${GCCDIR}"
+	check_error $? "Change directory failed."
+
+	BUILDPATH="${CROSS_PREFIX}/bin:${PATH}"
+
+	change_title "libgcc: make (${TARGET})"
+
+	PATH="${BUILDPATH}" make all-target-libgcc -j$JOBS
+	check_error $? "Error compiling libgcc."
+	# TODO: libatomic and libstdc++ need some extra care
+	#    PATH="${BUILDPATH}" make all-target-libatomic -j$JOBS
+	#    check_error $? "Error compiling libatomic."
+	#    PATH="${BUILDPATH}" make all-target-libstdc++-v3 -j$JOBS
+	#    check_error $? "Error compiling libstdc++."
+
+	change_title "libgcc: install (${TARGET})"
+
+	PATH="${BUILDPATH}" make install-target-libgcc $DESTDIR_SPEC
+	#    PATH="${BUILDPATH}" make install-target-libatomic $DESTDIR_SPEC
+	#    PATH="${BUILDPATH}" make install-target-libstdc++-v3 $DESTDIR_SPEC
+	check_error $? "Error installing libgcc."
+}
+
+build_gdb() {
+	# This sets the TARGET variable
+	set_target_from_platform "$1"
+
+	WORKDIR="${BASEDIR}/${TARGET}"
+	GDBDIR="${WORKDIR}/gdb-${GDB_VERSION}"
+
+	echo ">>> Removing previous content"
+	cleanup_dir "${WORKDIR}"
+	mkdir -p "${WORKDIR}"
+
+	echo ">>> Processing GDB (${TARGET})"
 	mkdir -p "${GDBDIR}"
 	cd "${GDBDIR}"
 	check_error $? "Change directory failed."
 
-	change_title "GDB: configure (${PLATFORM})"
-	CFLAGS="-fcommon" PATH="$PATH:${INSTALL_DIR}/${PREFIX}/bin" "${BASEDIR}/downloads/gdb-${GDB_VERSION}/configure" \
+	change_title "GDB: configure (${TARGET})"
+	CFLAGS="-fcommon" "${BASEDIR}/downloads/gdb-${GDB_VERSION}/configure" \
 		"--target=${TARGET}" \
-		"--prefix=${PREFIX}" \
+		"--prefix=${CROSS_PREFIX}" \
 		"--program-prefix=${TARGET}-" \
 		--enable-werror=no
 	check_error $? "Error configuring GDB."
 
-	change_title "GDB: make (${PLATFORM})"
-	PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-gdb -j$JOBS
+	change_title "GDB: make (${TARGET})"
+	make all-gdb -j$JOBS
 	check_error $? "Error compiling GDB."
 
-	change_title "GDB: make (${PLATFORM})"
-	PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-gdb "DESTDIR=${INSTALL_DIR}"
+	change_title "GDB: install (${TARGET})"
+	make install-gdb $DESTDIR_SPEC
 	check_error $? "Error installing GDB."
-
+}
+
+install_pkg() {
+	echo ">>> Moving to the destination directory."
+	if $SYSTEM_INSTALL ; then
+		ring_bell
+		( set -x ; sudo -k cp -r -t "${CROSS_PREFIX}" "${INSTALL_DIR}${CROSS_PREFIX}/"* )
+	else
+		( set -x ; cp -r -t "${CROSS_PREFIX}" "${INSTALL_DIR}${CROSS_PREFIX}/"* )
+	fi
+}
+
+link_clang() {
 	# Symlink clang and lld to the install path.
 	CLANG="`which clang 2> /dev/null || echo "/usr/bin/clang"`"
 	LLD="`which ld.lld 2> /dev/null || echo "/usr/bin/ld.lld"`"
 
-	ln -s $CLANG "${INSTALL_DIR}/${PREFIX}/bin/${TARGET}-clang"
-	ln -s $LLD "${INSTALL_DIR}/${PREFIX}/bin/${TARGET}-ld.lld"
-
-	if $REAL_INSTALL ; then
-		echo ">>> Moving to the destination directory."
-		cp -r -t "${PREFIX}" "${INSTALL_DIR}/${PREFIX}/"*
-	fi
-
-	cd "${BASEDIR}"
-	check_error $? "Change directory failed."
-
-	echo ">>> Cleaning up"
-	cleanup_dir "${WORKDIR}"
-
-	echo
-	echo ">>> Cross-compiler for ${TARGET} installed."
+	ln -s $CLANG "${INSTALL_DIR}${CROSS_PREFIX}/bin/${TARGET}-clang"
+	ln -s $LLD "${INSTALL_DIR}${CROSS_PREFIX}/bin/${TARGET}-ld.lld"
 }
 
@@ -512,10 +527,12 @@
 			exit
 			;;
-		--no-install)
-			REAL_INSTALL=false
+		--with-gdb)
+			BUILD_GDB=true
 			shift
 			;;
-		--non-helenos-target)
-			USE_HELENOS_TARGET=false
+		--only-gdb)
+			BUILD_GDB=true
+			BUILD_BINUTILS=false
+			BUILD_GCC=false
 			shift
 			;;
@@ -529,4 +546,80 @@
 	show_usage
 fi
+
+PLATFORMS="amd64 arm32 arm64 ia32 ia64 mips32 mips32eb ppc32 riscv64 sparc64"
+
+run_one() {
+	$1 $PLATFORM
+}
+
+run_all() {
+	for x in $PLATFORMS ; do
+		$1 $x
+	done
+}
+
+run_parallel() {
+	for x in $PLATFORMS ; do
+		$1 $x &
+	done
+	wait
+}
+
+run_2way() {
+	$1 amd64 &
+	$1 arm32 &
+	wait
+
+	$1 arm64 &
+	$1 ia32 &
+	wait
+
+	$1 ia64 &
+	$1 mips32 &
+	wait
+
+	$1 mips32eb &
+	$1 ppc32 &
+	wait
+
+	$1 riscv64 &
+	$1 sparc64 &
+	wait
+}
+
+everything() {
+	RUNNER="$1"
+
+	prepare
+
+	if $BUILD_BINUTILS ; then
+		$RUNNER build_binutils
+
+		if $BUILD_GCC ; then
+			# gcc/libgcc may fail to build correctly if binutils is not installed first
+			echo ">>> Installing binutils"
+			install_pkg
+		fi
+	fi
+
+	if $BUILD_GCC ; then
+		$RUNNER build_gcc
+
+		# libgcc may fail to build correctly if gcc is not installed first
+		echo ">>> Installing GCC"
+		install_pkg
+
+		$RUNNER build_libgcc
+	fi
+
+	if $BUILD_GDB ; then
+		$RUNNER build_gdb
+	fi
+
+	echo ">>> Installing all files"
+	install_pkg
+
+	link_clang
+}
 
 case "$1" in
@@ -536,67 +629,15 @@
 		;;
 	amd64|arm32|arm64|ia32|ia64|mips32|mips32eb|ppc32|riscv64|sparc64)
-		prepare
-		build_target "$1"
+		PLATFORM="$1"
+		everything run_one
 		;;
 	"all")
-		prepare
-		build_target "amd64"
-		build_target "arm32"
-		build_target "arm64"
-		build_target "ia32"
-		build_target "ia64"
-		build_target "mips32"
-		build_target "mips32eb"
-		build_target "ppc32"
-		build_target "riscv64"
-		build_target "sparc64"
-		;;
-	"essential")
-		prepare
-		build_target "amd64"
-		build_target "arm32"
-		build_target "arm64"
-		build_target "ia32"
-		build_target "ia64"
-		build_target "mips32"
-		build_target "mips32eb"
-		build_target "ppc32"
-		build_target "sparc64"
+		everything run_all
 		;;
 	"parallel")
-		prepare
-		build_target "amd64" &
-		build_target "arm32" &
-		build_target "arm64" &
-		build_target "ia32" &
-		build_target "ia64" &
-		build_target "mips32" &
-		build_target "mips32eb" &
-		build_target "ppc32" &
-		build_target "riscv64" &
-		build_target "sparc64" &
-		wait
+		everything run_parallel
 		;;
 	"2-way")
-		prepare
-		build_target "amd64" &
-		build_target "arm32" &
-		wait
-
-		build_target "arm64" &
-		build_target "ia32" &
-		wait
-
-		build_target "ia64" &
-		build_target "mips32" &
-		wait
-
-		build_target "mips32eb" &
-		build_target "ppc32" &
-		wait
-
-		build_target "riscv64" &
-		build_target "sparc64" &
-		wait
+		everything run_2way
 		;;
 	*)
Index: tools/xcw/bin/helenos-pkg-config
===================================================================
--- tools/xcw/bin/helenos-pkg-config	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/xcw/bin/helenos-pkg-config	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,5 +1,6 @@
-#!/bin/bash
+#!/usr/bin/env python3
+
 #
-# Copyright (c) 2020 Jiri Svoboda
+# Copyright (c) 2024 Vojtech Horky
 # All rights reserved.
 #
@@ -32,77 +33,84 @@
 #
 
-XCW="$(dirname "$0")"
-BUILD_ROOT="$(dirname "$(dirname "$(dirname "$XCW")")")"
-if [ -z "$EXPORT_DIR" ]; then
-	EXPORT_DIR="$BUILD_ROOT/export"
-fi
 
-INCLUDE_DIR="$EXPORT_DIR/include"
-LIB_DIR="$EXPORT_DIR/lib"
+import argparse
+import os
+import sys
 
-libmath_cflags="-I$INCLUDE_DIR/libmath"
-libmath_libs="$LIB_DIR/libmath.a"
+# Package dependencies: always list only immediate dependencies so that
+# we can get proper ordering for static libraries
+CONFIG_DEPENDENCIES = {
+    'libui': ['libdisplay', 'libcongfx', 'libgfxfont', 'libriff', 'libmemgfx', 'libconsole'],
+    'libdisplay': ['libgfx', 'libipcgfx', 'libinput'],
+    'libconsole': ['libinput', 'liboutput'],
+    'libipcfgfx': ['libgfx'],
+    'libgfximage': ['libpixconv'],
+}
 
-libui_cflags="-I$INCLUDE_DIR/libui -I$INCLUDE_DIR/libdisplay -I$INCLUDE_DIR/libgfx -I$INCLUDE_DIR/libipcgfx -I$INCLUDE_DIR/libcongfx"
-libui_libs="$LIB_DIR/libui.a $LIB_DIR/libdisplay.a $LIB_DIR/libipcgfx.a $LIB_DIR/libcongfx.a $LIB_DIR/libgfx.a $LIB_DIR/libgfxfont.a $LIB_DIR/libriff.a $LIB_DIR/libmemgfx.a"
+CONFIG_CFLAGS = {
+}
 
-libgfximage_cflags="-I$INCLUDE_DIR/libgfximage"
-libgfximage_libs="$LIB_DIR/libgfximage.a $LIB_DIR/libpixconv.a"
+CONFIG_LIBS = {
+}
 
-libhound_cflags="-I$INCLUDE_DIR/libhound"
-libhound_libs="$LIB_DIR/libhound.a"
+def get_with_dependencies(package, dependencies_first=True):
+    deps = CONFIG_DEPENDENCIES.get(package, [])
+    all_deps = [
+        i
+        for d in deps
+        for i in get_with_dependencies(d, dependencies_first)
+    ]
+    result = (all_deps if dependencies_first else []) + [package] + ([] if dependencies_first else all_deps)
+    seen = set()
+    return [
+        i
+        for i in result
+        if not (i in seen or seen.add(i))
+    ]
 
-libpcm_cflags="-I$INCLUDE_DIR/libpcm"
-libpcm_libs="$LIB_DIR/libpcm.a"
+def get_build_root():
+    dn = lambda x : os.path.dirname(x)
+    return dn(dn(dn(dn(os.path.abspath(sys.argv[0])))))
 
-libgfx_cflags="-I$INCLUDE_DIR/libgfx"
-libgfx_libs="$LIB_DIR/libgfx.a"
+def main():
+    args = argparse.ArgumentParser(description='pkg-config-like tool for HelenOS')
+    args.add_argument(
+        '--cflags',
+        dest='cflags',
+        action='store_true',
+        default=False,
+        help='Print required C compiler flags to stdout.'
+    )
+    args.add_argument(
+        '--libs',
+        dest='libs',
+        action='store_true',
+        default=False,
+        help='Print required linker flags to stdout.'
+    )
+    args.add_argument('packages', metavar='PACKAGE', nargs='+')
 
-libipcgfx_cflags="-I$INCLUDE_DIR/libipcgfx"
-libipcgfx_libs="$LIB_DIR/libipcgfx.a"
+    config = args.parse_args()
 
-libdisplay_cflags="-I$INCLUDE_DIR/libdisplay"
-libdisplay_libs="$LIB_DIR/libdisplay.a"
+    export_dir = os.getenv('EXPORT_DIR', get_build_root() + '/export')
 
-action=none
-pkg=
+    result = []
+    for package in config.packages:
+        if config.cflags:
+            for i in get_with_dependencies(package, False):
+                if i in CONFIG_CFLAGS:
+                    result.extend(CONFIG_CFLAGS[i])
+                else:
+                    result.append(f'-I{export_dir}/include/{i}')
+        if config.libs:
+            for i in get_with_dependencies(package, False):
+                if i in CONFIG_LIBS:
+                    result.extend(CONFIG_LIBS[i])
+                else:
+                    result.append(f'{export_dir}/lib/{i}.a')
 
-while [ ".$1" != . ] ; do
-	case ".$1" in
-	(.--cflags) action=cflags;;
-	(.--libs) action=libs;;
-	(.-*) echo "Uknwown option $1" >&2; exit 1;;
-	(.*)
-	    case "$1" in
-	    (libui) ;;
-	    (libgfximage) ;;
-	    (libmath) ;;
-	    (libhound) ;;
-	    (libpcm) ;;
-	    (libgfx) ;;
-	    (libipcgfx) ;;
-	    (libdisplay) ;;
-	    (*) echo "Unknown package $1" >&2; exit 1;;
-	    esac
+    print(' '.join(result))
 
-	    echo "$pkg" | grep -w "$1" >/dev/null 2>&1
-	    if [ $? -ne 0 ] ; then
-		    pkg="$pkg $1"
-	    fi;;
-	esac
-	shift 1
-done
 
-if [ ."$pkg" = . ]; then
-	echo "Package name(s) required." >&2
-	exit 1
-fi
-
-for p in $pkg ; do
-	case "$action" in
-	(cflags) eval "printf ' %s' \$${p}_cflags";;
-	(libs) eval "printf ' %s' \$${p}_libs";;
-	esac
-done
-
-echo
+if __name__ == '__main__':
+    main()
Index: uspace/app/aboutos/aboutos.c
===================================================================
--- uspace/app/aboutos/aboutos.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/aboutos/aboutos.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,372 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup aboutos
+ * @{
+ */
+/** @file About HelenOS
+ */
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <gfximage/tga.h>
+#include <macros.h>
+#include <stdbool.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+#include <str_error.h>
+#include <ui/fixed.h>
+#include <ui/image.h>
+#include <ui/label.h>
+#include <ui/pbutton.h>
+#include <ui/resource.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+
+#include "aboutos.h"
+#include "images.h"
+
+#define NAME  "aboutos"
+
+static void aboutos_wnd_close(ui_window_t *, void *);
+static void aboutos_wnd_kbd(ui_window_t *, void *, kbd_event_t *);
+
+static ui_window_cb_t window_cb = {
+	.close = aboutos_wnd_close,
+	.kbd = aboutos_wnd_kbd
+};
+
+static void pb_clicked(ui_pbutton_t *, void *);
+
+static ui_pbutton_cb_t pbutton_cb = {
+	.clicked = pb_clicked
+};
+
+/** Window close button was clicked.
+ *
+ * @param window Window
+ * @param arg Argument (aboutos)
+ */
+static void aboutos_wnd_close(ui_window_t *window, void *arg)
+{
+	aboutos_t *aboutos = (aboutos_t *) arg;
+
+	ui_quit(aboutos->ui);
+}
+
+/** About HelenOS window keyboard event handler.
+ *
+ * @param window Window
+ * @param arg Argument (ui_prompt_dialog_t *)
+ * @param event Keyboard event
+ */
+static void aboutos_wnd_kbd(ui_window_t *window, void *arg,
+    kbd_event_t *event)
+{
+	aboutos_t *aboutos = (aboutos_t *) arg;
+
+	(void)window;
+
+	if (event->type == KEY_PRESS &&
+	    (event->mods & (KM_CTRL | KM_SHIFT | KM_ALT)) == 0) {
+		if (event->key == KC_ENTER) {
+			/* Quit */
+			ui_quit(aboutos->ui);
+
+		}
+	}
+
+	ui_window_def_kbd(window, event);
+}
+
+/** Push button was clicked.
+ *
+ * @param pbutton Push button
+ * @param arg Argument (aboutos)
+ */
+static void pb_clicked(ui_pbutton_t *pbutton, void *arg)
+{
+	aboutos_t *aboutos = (aboutos_t *) arg;
+
+	ui_quit(aboutos->ui);
+}
+
+static void print_syntax(void)
+{
+	printf("Syntax: %s [-d <display-spec>]\n", NAME);
+}
+
+int main(int argc, char *argv[])
+{
+	int i;
+	aboutos_t aboutos;
+	ui_t *ui = NULL;
+	ui_wnd_params_t params;
+	ui_window_t *window = NULL;
+	ui_resource_t *ui_res;
+	gfx_bitmap_params_t logo_params;
+	gfx_bitmap_t *logo_bmp;
+	gfx_context_t *gc;
+	gfx_rect_t logo_rect;
+	gfx_rect_t rect;
+	gfx_coord2_t off;
+	const char *dspec = UI_ANY_DEFAULT;
+	errno_t rc;
+
+	i = 1;
+	while (i < argc) {
+		if (str_cmp(argv[i], "-d") == 0) {
+			++i;
+			if (i >= argc) {
+				printf("Argument missing.\n");
+				print_syntax();
+				return 1;
+			}
+
+			dspec = argv[i++];
+		} else {
+			printf("Invalid option '%s'.\n", argv[i]);
+			print_syntax();
+			return 1;
+		}
+	}
+
+	rc = ui_create(dspec, &ui);
+	if (rc != EOK) {
+		printf("Error creating UI on display %s.\n", dspec);
+		return rc;
+	}
+
+	ui_wnd_params_init(&params);
+	params.caption = "About HelenOS";
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		params.rect.p0.x = 0;
+		params.rect.p0.y = 0;
+		params.rect.p1.x = 45;
+		params.rect.p1.y = 15;
+	} else {
+		params.rect.p0.x = 0;
+		params.rect.p0.y = 0;
+		params.rect.p1.x = 350;
+		params.rect.p1.y = 275;
+	}
+
+	memset((void *) &aboutos, 0, sizeof(aboutos));
+	aboutos.ui = ui;
+
+	rc = ui_window_create(ui, &params, &window);
+	if (rc != EOK) {
+		printf("Error creating window.\n");
+		return rc;
+	}
+
+	ui_window_set_cb(window, &window_cb, (void *) &aboutos);
+	aboutos.window = window;
+
+	ui_res = ui_window_get_res(window);
+	gc = ui_window_get_gc(window);
+
+	rc = decode_tga(gc, (void *) helenos_tga, helenos_tga_size,
+	    &logo_bmp, &logo_rect);
+	if (rc != EOK) {
+		printf("Unable to decode logo.\n");
+		return 1;
+	}
+
+	gfx_bitmap_params_init(&logo_params);
+	logo_params.rect = logo_rect;
+
+	rc = ui_fixed_create(&aboutos.fixed);
+	if (rc != EOK) {
+		printf("Error creating fixed layout.\n");
+		return rc;
+	}
+
+	rc = ui_image_create(ui_res, logo_bmp, &logo_rect, &aboutos.image);
+	if (rc != EOK) {
+		printf("Error creating label.\n");
+		return rc;
+	}
+
+	off.x = 76;
+	off.y = 42;
+	gfx_rect_translate(&off, &logo_rect, &rect);
+
+	/* Adjust for frame width (2 x 1 pixel) */
+	rect.p1.x += 2;
+	rect.p1.y += 2;
+	ui_image_set_rect(aboutos.image, &rect);
+	ui_image_set_flags(aboutos.image, ui_imgf_frame);
+
+	rc = ui_fixed_add(aboutos.fixed, ui_image_ctl(aboutos.image));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	/* Release label */
+
+	rc = ui_label_create(ui_res, "HelenOS " STRING(HELENOS_RELEASE)
+	    " (" STRING(HELENOS_CODENAME) ")", &aboutos.lrelease);
+	if (rc != EOK) {
+		printf("Error creating label.\n");
+		return rc;
+	}
+
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 1;
+		rect.p0.y = 5;
+		rect.p1.x = 44;
+		rect.p1.y = 6;
+	} else {
+		rect.p0.x = 10;
+		rect.p0.y = 140;
+		rect.p1.x = 340;
+		rect.p1.y = 160;
+	}
+
+	ui_label_set_rect(aboutos.lrelease, &rect);
+	ui_label_set_halign(aboutos.lrelease, gfx_halign_center);
+
+	rc = ui_fixed_add(aboutos.fixed, ui_label_ctl(aboutos.lrelease));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	/* Copyright label */
+
+	rc = ui_label_create(ui_res, STRING(HELENOS_COPYRIGHT), &aboutos.lcopy);
+	if (rc != EOK) {
+		printf("Error creating label.\n");
+		return rc;
+	}
+
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 1;
+		rect.p0.y = 6;
+		rect.p1.x = 44;
+		rect.p1.y = 7;
+	} else {
+		rect.p0.x = 10;
+		rect.p0.y = 160;
+		rect.p1.x = 340;
+		rect.p1.y = 180;
+	}
+
+	ui_label_set_rect(aboutos.lcopy, &rect);
+	ui_label_set_halign(aboutos.lcopy, gfx_halign_center);
+
+	rc = ui_fixed_add(aboutos.fixed, ui_label_ctl(aboutos.lcopy));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	/* Architecture label */
+
+	rc = ui_label_create(ui_res, "Running on " STRING(UARCH), &aboutos.larch);
+	if (rc != EOK) {
+		printf("Error creating label.\n");
+		return rc;
+	}
+
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 1;
+		rect.p0.y = 9;
+		rect.p1.x = 44;
+		rect.p1.y = 10;
+	} else {
+		rect.p0.x = 10;
+		rect.p0.y = 190;
+		rect.p1.x = 340;
+		rect.p1.y = 210;
+	}
+
+	ui_label_set_rect(aboutos.larch, &rect);
+	ui_label_set_halign(aboutos.larch, gfx_halign_center);
+
+	rc = ui_fixed_add(aboutos.fixed, ui_label_ctl(aboutos.larch));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	/* OK button */
+
+	rc = ui_pbutton_create(ui_res, "OK", &aboutos.pbok);
+	if (rc != EOK) {
+		printf("Error creating button.\n");
+		return rc;
+	}
+
+	ui_pbutton_set_cb(aboutos.pbok, &pbutton_cb, (void *) &aboutos);
+
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 17;
+		rect.p0.y = 13;
+		rect.p1.x = 28;
+		rect.p1.y = 14;
+	} else {
+		rect.p0.x = 125;
+		rect.p0.y = 235;
+		rect.p1.x = 225;
+		rect.p1.y = rect.p0.y + 28;
+	}
+
+	ui_pbutton_set_rect(aboutos.pbok, &rect);
+	ui_pbutton_set_default(aboutos.pbok, true);
+
+	rc = ui_fixed_add(aboutos.fixed, ui_pbutton_ctl(aboutos.pbok));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	ui_window_add(window, ui_fixed_ctl(aboutos.fixed));
+
+	rc = ui_window_paint(window);
+	if (rc != EOK) {
+		printf("Error painting window.\n");
+		return rc;
+	}
+
+	ui_run(ui);
+
+	ui_window_destroy(window);
+	ui_destroy(ui);
+
+	return 0;
+}
+
+/** @}
+ */
